#ifndef __sockrpc_HXX
#include "sockrpc.hxx"
#endif

#ifndef __dbvue_clnt_HXX
#define __dbvue_clnt_HXX

class proxy_RemoteDBVue : public SvcClient {

  public :
  proxy_RemoteDBVue(int family=AF_INET) : proxy_SvcClient("RemoteDBVue", family) {};
  proxy_RemoteDBVue(char* n, int f) : proxy_SvcClient(n,f) {}
  void connect(char* userid, int pid, char* callb, int delta)
  {
    int numproc = 0 ;
    (*(SvcSocket*)this) << numproc << userid << pid << callb << delta << svcflush ;
  } ;
  void upgrade(const ListVal<PID>& in, ListVal<PID>& eject)
  {
    int numproc = 1 ;
    (*(SvcSocket*)this) << numproc << in << svcflush ;
    (*(SvcSocket*)this) >> eject;
  } ;
  void release(int delta, const ListVal<PID>& in, ListVal<PID>& k, ListVal<PID>& nk)
  {
    int numproc = 2 ;
    (*(SvcSocket*)this) << numproc << delta << in << svcflush ;
    (*(SvcSocket*)this) >> k >> nk;
  } ;
  int sync()
  {
    int numproc = 3 ;
    int result ;
    (*(SvcSocket*)this) << numproc << svcflush ;
    (*(SvcSocket*)this) >> result;
    return result ;
  } ;
  void abort(int delta)
  {
    int numproc = 4 ;
    (*(SvcSocket*)this) << numproc << delta << svcflush ;
  } ;
  int secondphase()
  {
    int numproc = 5 ;
    int result ;
    (*(SvcSocket*)this) << numproc << svcflush ;
    (*(SvcSocket*)this) >> result;
    return result ;
  } ;
  void write(Page p, PID pid)
  {
    int numproc = 6 ;
    (*(SvcSocket*)this) << numproc << p << pid << svcflush ;
  } ;
  void freepage(PID pid)
  {
    int numproc = 7 ;
    (*(SvcSocket*)this) << numproc << pid << svcflush ;
  } ;
  void readfirst(Page& p, PID pid)
  {
    int numproc = 8 ;
    (*(SvcSocket*)this) << numproc << pid << svcflush ;
YOO_VirtualMemory->sync() ;
    (*(SvcSocket*)this) >> p;
  } ;
  void readnext(Page& p, PID pid)
  {
    int numproc = 9 ;
    (*(SvcSocket*)this) << numproc << pid << svcflush ;
    (*(SvcSocket*)this) >> p;
  } ;
  PID allocation(int volNo, int num)
  {
    int numproc = 10 ;
    PID result ;
    (*(SvcSocket*)this) << numproc << volNo << num << svcflush ;
    (*(SvcSocket*)this) >> result;
    return result ;
  } ;
  int lock(PID pid, Lock l)
  {
    int numproc = 11 ;
    int result ;
    (*(SvcSocket*)this) << numproc << pid << l << svcflush ;
    (*(SvcSocket*)this) >> result;
    return result ;
  } ;
} ; 



#endif
